#define LIB_NAME "MyExtension"
#define MODULE_NAME "Test"

#include <dmsdk/sdk.h>

#if defined(DM_PLATFORM_IOS)
extern void RegisterMyAppDelegate();
extern void TestModalViewController();
#endif

static int Initialize(lua_State* L)
{
	printf("Inside Initialize!!!\n");
	
#if defined(DM_PLATFORM_IOS)
	TestModalViewController();
#endif
	
	return 0;
}

static const luaL_reg Module_methods[] =
{
	{"Initialize", Initialize},
	{0, 0}
};

static void LuaInit(lua_State* L)
{
	luaL_register(L, MODULE_NAME, Module_methods);
	lua_pop(L, 1);
}

static dmExtension::Result AppInitializeMyExtension(dmExtension::AppParams* params)
{
#if defined (DM_PLATFORM_IOS)
	RegisterMyAppDelegate();
#endif

	return dmExtension::RESULT_OK;
}

static dmExtension::Result InitializeMyExtension(dmExtension::Params* params)
{
	LuaInit(params->m_L);
	printf("Registered %s Extension\n", MODULE_NAME);
	
	return dmExtension::RESULT_OK;
}

static dmExtension::Result AppFinalizeMyExtension(dmExtension::AppParams* params)
{	
	return dmExtension::RESULT_OK;
}

static dmExtension::Result FinalizeMyExtension(dmExtension::Params* params)
{	
	return dmExtension::RESULT_OK;
}

DM_DECLARE_EXTENSION(MyExtension, LIB_NAME, AppInitializeMyExtension, AppFinalizeMyExtension, InitializeMyExtension, 0, 0, FinalizeMyExtension)