#if defined (DM_PLATFORM_IOS)

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#include <dmsdk/sdk.h>

//// App delegate (necessary since we need all the orientations) //////
static id<UIApplicationDelegate> g_MyAppDelegate;

@interface MyAppDelegate : NSObject <UIApplicationDelegate>
@end

@implementation MyAppDelegate
-(UIInterfaceOrientationMask) application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window
{
	return UIInterfaceOrientationMaskAll;
}
@end

void RegisterMyAppDelegate()
{
	g_MyAppDelegate = [[MyAppDelegate alloc] init];
	dmExtension::RegisteriOSUIApplicationDelegate(g_MyAppDelegate);
}
/////////////////////

//// Modal view controller (a simple landscape view controller) /////
@interface MyViewController : UIViewController
@end

@implementation MyViewController
-(BOOL) prefersStatusBarHidden
{
	return YES;
}

-(BOOL) shouldAutorotate
{
	return YES;
}

-(NSUInteger) supportedInterfaceOrientations
{
	return UIInterfaceOrientationMaskLandscape;		
}
@end
///////////////////////

static UIViewController* parentViewController;
static MyViewController* myViewController;
static UIWebView* webView;

void TestModalViewController()
{
	UIWindow* parentWindow = (UIWindow*)dmGraphics::GetNativeiOSUIWindow();
	parentViewController = [parentWindow rootViewController];

	dispatch_async(dispatch_get_main_queue(), ^
	{
		// Create the modal view controller
		myViewController = [[MyViewController alloc] init];
		myViewController.view.frame = [[UIScreen mainScreen] bounds];

		// Create the webView
		webView = [[UIWebView alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
		webView.backgroundColor = [UIColor redColor];
		webView.opaque = NO;
		webView.scrollView.scrollEnabled = NO;
		webView.scrollView.bounces = NO;
		webView.allowsInlineMediaPlayback = YES;
		webView.mediaPlaybackRequiresUserAction = NO;		
		webView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
		webView.delegate = nil;

		// Add the webView to the modal view controller
		[myViewController.view addSubview:webView];

		// Present it
		[parentViewController presentViewController:myViewController animated:NO completion:^
		{
			// Load the url
			NSString *urlString = [NSString stringWithUTF8String:"https://www.google.ro"];
			[webView loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:urlString]]];
		}];
	});

	// Dismiss it after 6 seconds
	dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(6.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^	
	{
		[parentViewController dismissViewControllerAnimated:NO completion:^
		{
			[myViewController release];
		}];	
	});
	////
}

#endif